// October 15th 2015  renamed TVLBIN.c

// LOUDSTEREO3.C  Original, adding inst_sones, ave1_sones & ave2_sones from left & right channel -> stereo

// use N_E  (156) when needing a static integer in place of N_Es which is defined as (EEND*$)



// in variable names, sig = signal

#include "readfile.h"

struct formathead{
  USHORT w_format;		  /* 16 bit number = 1 for PCM */
  USHORT nchans;			  /* 1 or 2 channels */
  ULONG  clockHz;			  /* sampling clock */
  ULONG  bytes_sec;		  /* clockHz*nchans*bytes_sample */
  USHORT bytes;				  /* 2=16 bit mono, 4 = 16 bit stereo */
  USHORT bits_sample;		/* 16 for us */
  ULONG  data_bytes;		/* from DATA chunk */
};


// GLOBALS
short verbose; // this global variable is set with -v on the command line

// for saving phons & sones (instant, average1 and average2) as we go along from time = av_from (ms)
long tot_blocks;
double *ch_inst_sone[2],  *ch_inst_phon[2],  *ch_ave1_sone[2],  *ch_ave1_phon[2],  *ch_ave2_sone[2],  *ch_ave2_phon[2];
double *stereo_inst_sone, *stereo_inst_phon, *stereo_ave1_sone, *stereo_ave1_phon, *stereo_ave2_sone, *stereo_ave2_phon;

char fir_name[2][20]; // for fir coefft file e.g. ff.32k, df.32k, midear.32k

//--------------------------------------------------
void main(int argc, char **argv)
{
  void dconvlv(double data[], unsigned long n, double respns[], unsigned long m,int isign, double ans[]);
  struct formathead sig_head, mono_head[2]; // mono_head for separated mono channels
  
  //	short *audible1, *audible2;								// arrays which will contain 0/1 for inaudible/audible for average1 & average2 of stereo signal
  
  short prt = FALSE;
  short *inData; // array pointer to hold total stereo data
  short	*sig_inData_left, *sig_inData_right; // array pointers to hold left & right channel data
  short *sigraw[2];    // for saving signal waveforms in 16 bit form
  double *sigraw_f[2];  // & in double form

  double **ch1_inst_sploud, **ch2_inst_sploud; //, sones, phons;
  //  double *sp1_loud, *sp2_loud; // For holding left & right channel N_Es (156) values of specific loudness dor binaural stuff
  //  int tot_audible1 = 0, tot_audible2 = 0;		// used in calc % audible
  //	double pc_audible1, pc_audible2;					// percentage audible in averages1 & 2
  double ex_include = 60.0; // default, can change on command line -x dB,  any freq component more than ex_include below the 
  // most intense component is discarded
  ULONG av_from = 0, av_to = 0, ultemp;//    sig_samples
  long indx, sig_nSamples;
  long sig_start;
  long retval;
  long sig_cb_val[2]; // sampling freq and calibration level values read from files
  
  long  channel_no, i, j, c, nblock;
  ULONG total_bytes, sig_len_bytes, sig_mono_data_bytes;
  // sig_used is the number of 16bit samples over which the loudness is printed out
  // all_sig_used is the number of 16bit samples from the signal start to the end of where the loudness is printed out
  ULONG sig_used, all_sig_used;
  
  
  // FLAGS
  short bkg_end=TRUE;  // flag for marking when bkg input file has finished being read, only used here for passing into st_loudness3()
  short stereo_sigfile_in = FALSE;
  short cl_sig_cb = FALSE; // command line calibration level for signal & background
  short monaural = TRUE; // binaural default, use command line -m for monaural     FOR STEREO SIGNAL MONAURAL IS ALWAYS TRUE FOR EACH CHANNEL
  short stereo = FALSE;
  short Nflag = FALSE; // make TRUE with -N Nfile to save the 'loudness spectrum' in text file Nfile[2][256]
  short do_fir[2] = {FALSE,FALSE}; // make TRUE to force filtering of the 32k sampled sound
  //do_fir[0] for left channel, do_fir[1] for right channel
  //use -f fir_name for the left channel
  //    -F fir_name where fir_name is a filter coefficient file e.g. ff.32k
  short av_to_flag = FALSE; // where to finish the loudness calculation (& averaging) set TRUE with e.g. -e 1000 to finish at 1000 ms
  
  short	cl_sig_sc = FALSE, cl_bkg_sc = FALSE; // make true if a command line signal / bkg scale is asked for. 
  // signal: -s sig_scale_dB,   background: -S bkg_scale_dB
  short do_scale_sig = FALSE, do_scale_bkg = FALSE; // if the signal & bkg calib levels are different one of them will need to be scaled
  // so they have the same calibration level
  double sig_scale_dB = 0.0, bkg_scale_dB = 0.0;    // command line values for scaling of signal (-s dB) and bkg (-S dB)
  double calib_scale = 1.0, sig_calib = 1.0, both_calib = 1.0; // value used to scale sig / bkg
  double sigRMS[2], sigP56[2], sigPEAK[2]; // left & right channels if stereo
  double total_ms;
  double mean1_sone[2] = {0.0,0.0};  // for running value of average1 left & right channel
  double mean2_sone[2] = {0.0,0.0};  // for running value of average left & right channel
  double mean_av1 = 0.0, max_av1 = 0.0, mean_av2 = 0.0, max_av2 = 0.0; // means of sones
  
  double  max_av1_sones = -100.0;
  double  max_av2_sones = -100.0;
  double  max_av1_phons = -100.0;
  double  max_av2_phons = -100.0;
  
  // names of signal file & bkg file
  char stereo_sigfile[256], bkgfile[256], Nfilename[256] ; // input file & optional loudness spectrum file for left & right channels channels 
  char mono_sig_file[2][20] = {"mono_left.wav","mono_right.wav"};
  char sig_fir_file[2][20]  = {"mono_left_fir.wav","mono_right_fir.wav"};
  char calib_txt[20];
  
  char firnames[200]; // get in text from command line using -F (xxx,yyy)   xxx & yyy are FIR file names, can be none for no filtering
  FILE *stereo_sig_fd=NULL, *bkg_fd=NULL;
  FILE *mono_sig_fd[2] = {NULL,NULL};
  struct stat firfile_stat;
  
  extern char *optarg;
  extern int optind;
  
  
  // Required stuff for the binaural convolution etc
#define GAUSS_PTS   145
#define CONVLV_PTS  256
#define CONVLV_PTS2 (2 * CONVLV_PTS)
  short  print400_600;
  int isign = 1, Ecounter;
  double  inhib_sones1, inhib_sones2, bin_sones, bin_phons;
  double *sp1_loud, *sp2_loud, *inhib_sp1_loud,  *inhib_sp2_loud;
  double *smooth1, *smooth2, *inhib1, *inhib2, *E_frqHz;
  double *gauss_wf, *gauss_wf_sav;
  double Broad1, g, abs_g, temp;
  double inhib_P = 1.5979;  //orig that had been adjusted to give 1 sone = 40 & binomial sone = monaural * 1.5
  double mono_sones[2];
  
  
  sp1_loud          = dvector(1l,(long)CONVLV_PTS);   // original mono specific loud, zero padded channel 1
  sp2_loud          = dvector(1l,(long)CONVLV_PTS);   // channel 2  1st N_Es (156) points sp_loud, rest up to CONVLV_PTS (256) zeros
  inhib_sp1_loud    = dvector(1l,(long)N_Es);         // inhibited mono specific loud, channel 1
  inhib_sp2_loud    = dvector(1l,(long)N_Es);         // inhibited mono specific loud, channel 2
  smooth1           = dvector(1l,(long)CONVLV_PTS2);  // intermediate smoothed specific loud, channel 1
  smooth2           = dvector(1l,(long)CONVLV_PTS2);  // intermediate smoothed specific loud, channel 2
  inhib1            = dvector(1l,(long)N_Es);         // intermediate inhibition or gain values used to divide sp1_loud
  inhib2            = dvector(1l,(long)N_Es);         // intermediate inhibition or gain values used to divide sp2_loud
  E_frqHz           = dvector(1l,(long)N_Es);
  gauss_wf          = dvector(1l,(long)CONVLV_PTS);   // 1st GAUSS_PTS (145) of 256  set to wrapped round gaussian 
  gauss_wf_sav      = dvector(1l,(long)CONVLV_PTS);   // save copy of gauss function
  
  
  verbose = FALSE;
  print400_600 = FALSE;
  
  while ((c = getopt(argc, argv, "i:Ivb:e:N:c:x:F:4")) != EOF)
    switch (c) {
  case 'i': strcpy(stereo_sigfile,optarg); stereo_sigfile_in = TRUE ; break;
  case 'I': info(); exit(0);
  case 'v': verbose = TRUE; break;
  case 'b': av_from = atol(optarg); break;                     // where to (b)egin loudness calc
  case 'e': av_to   = atol(optarg); av_to_flag = TRUE; break;  // where to (e)nd   loudness calc
    //	case 'N': strcpy(Nfilename,optarg); Nflag = TRUE ; break;
  case 'c': strcpy(calib_txt,optarg); cl_sig_cb = TRUE; break;  // -c (80,95) would be 80 dB calib for left channel, 95 for right
  case 'x': ex_include = atof(optarg);break;
  case 'F': strcpy(firnames,optarg);do_fir[0] = do_fir[1] = TRUE; break;  // -F ( xxx,yyy) for left & right channel FIR file name, if xxx or yyy = none, no filtering will be done on that channel
  case '4': print400_600 = TRUE;break; // to just print average1 time & phons from 400 to 599 ms (1 cycle for OLEK/BIN_BEATS/  stuff)
  case '?': printf("unknown file option %s\n",argv[optind]); exit(1);
  }
  


// Make default filter diffuse field i.e. if not filter on command line, use the filter coefficient file  df.32k which MUST be in the directory 
  
  if(!do_fir[0]){
    do_fir[0] = do_fir[1] = TRUE;
    strcpy(firnames,"(df.32k,df.32k)");
  }
  if(verbose) printf("%s\n",firnames);


  if(!stereo_sigfile_in){
    fprintf(stderr,"------------------------------------------------------------\n");
    fprintf(stderr,"\n!!! minimum requirement is -i input_sig  (stereo WAV file)\n");
    fprintf(stderr,"\n------------------------------------------------------------\n");
    info();
    exit(0);
  }
  if(!print400_600) printf("\nINPUT SIGNAL FILE: %s\n",stereo_sigfile);
  
  if((av_to < av_from) && av_to_flag){
    fprintf(stderr,"\nTime to start from (-b  begin_time) must be before the time to finish (-e  end_time)\n");
    exit(0);
  }
  
  if(verbose){
    printf("\nATTACK1 %7.4f RELEASE1  %7.4f ATTACK2 %7.4f RELEASE2 %7.4f\n\n",ATTACK1,RELEASE1,ATTACK2,RELEASE2);
//    printf("\nin ms: ATTACK1 %6.1f RELEASE1  %6.1f ATTACK2 %6.1f RELEASE2 %6.1f ms\n\n",
    printf(" ATTACK / RELEASE times in ms (rounded)\n");
    printf(" ATTACK1  %6.1f ms\n",-1.0/log(1.0-ATTACK1) +0.3);
    printf(" RELEASE1 %6.1f ms\n",-1.0/log(1.0-RELEASE1)+0.5);
    printf(" ATTACK2  %6.1f ms\n",-1.0/log(1.0-ATTACK2)+0.5);
    printf(" RELEASE2 %6.1f ms\n",-1.0/log(1.0-RELEASE2)+0.5);

//    printf("Program TVLBIN measures the loudness of a stereo signal file in quiet.\n\n");
  }
  // READ SIGNAL FILE SAMPLING FREQ AND CALIBRATION LEVEL
  
  //read format header and number of data bytes in wav signal file	
  read_headers(stereo_sigfile, &stereo_sig_fd, &total_bytes, &sig_len_bytes, &sig_head);
//  if(verbose) print_format(&sig_head);
  if(sig_head.nchans == 2) stereo = TRUE;
  else {
    fprintf(stderr,"%s is not a STEREO WAV FILE",stereo_sigfile);
    if(sig_head.nchans == 1) fprintf(stderr,", it is MONO");
    fprintf(stderr,"\n\n");
    exit(0);
  }

  if(sig_head.clockHz != 32000) {
    fprintf(stderr,"%s is sampled at %d Hz, not 32000 Hz\n\n",stereo_sigfile,sig_head.clockHz);
    exit(0);
  }
  
  //sort out FIR coefft file names from e.g.(xxx,yyy)
  if(do_fir[0]){
    fir_filenames(firnames, do_fir);
    if(do_fir[0]){
//      printf("!! left  channel coefft file: %s\n",fir_name[0]);
      retval = stat(fir_name[0],&firfile_stat);
      if(retval != 0) {
        printf("Left channel FIR coefft file %s not found\n",fir_name[0]);
        exit(0);
      }
    }
    if(do_fir[1]){
//      printf("!! right channel coefft file: %s\n",fir_name[1]);
      retval = stat(fir_name[0],&firfile_stat);
      if(retval != 0) {
        printf("right channel FIR coefft file %s not found\n",fir_name[1]);
        exit(0);
      }
    }
    printf("\n\n");
  }
  
  //CHECK FOR & READ CALIBRATION LEVEL(S) FOR SIGNAL FILE
  if(!get_fn_nums("CdB(", stereo_sigfile, sig_cb_val, stereo)){
    if(!cl_sig_cb){
      sig_cb_val[0] = (int)GetDouble("What (integer) calibration level do you want for the left  chan of sig file",100,"");
      sig_cb_val[1] = (int)GetDouble("What (integer) calibration level do you want for the right chan of sig file",100,"");
    }
  }
  else if(verbose) printf("Stereo sig calib levels from FILENAME are %d  & %d\n",sig_cb_val[0],sig_cb_val[1]);
  
  if(cl_sig_cb){ // 
    check_calib_txt(calib_txt);
    sscanf(calib_txt,"(%d,%d)",&sig_cb_val[0],&sig_cb_val[1]);
    //		printf("sig_cb_val   %d  %d\n",sig_cb_val[0],sig_cb_val[1]);
    if(verbose){
      printf("From command line  left channel sig calibration level= %d dB, overriding any other values\n",sig_cb_val[0]);
      printf("From command line right channel sig calibration level= %d dB, overriding any other values\n",sig_cb_val[1]);
    }
    if(verbose) printf("Stereo sig calib levels from COMMAND LINE are %d  & %d\n",sig_cb_val[0],sig_cb_val[1]);
  }
		
  if (verbose) printf("xxxx4\n");
		
  total_ms = sig_head.data_bytes/(32.0*sig_head.bytes); // total 32k data as ms,  64 = number of bytes per ms
  if(verbose) printf("total_ms = %.1f\n",total_ms); // not used at moment 15/11/2002
		
		// calc number of samples used in the part of the signal used for the loudness calc  FOR EACH CHANNEL
  if(av_to_flag) ultemp = av_to;
  else ultemp = (ULONG)(total_ms - 1);
  if(ultemp > (ULONG)total_ms - 1) ultemp = (ULONG)total_ms - 1;
  sig_used = (ultemp - av_from + 1) * 32; // number of signal samples analysed
  all_sig_used = av_from*32 + sig_used; // number of samples from signal start to required end of signal
		
		// number of ms blocks from time 0 to the end of where the loudness is calculated, used to create arrays
  tot_blocks = all_sig_used/32;
  if(!av_to_flag) tot_blocks++;
  
//  printf("\n\nmain:   tot_blocks %ld\n\n",tot_blocks);
  
  ch1_inst_sploud = dmatrix(1,(long)N_Es,1,tot_blocks);  // using NR method for 1 start matrices
  ch2_inst_sploud = dmatrix(1,(long)N_Es,1,tot_blocks);
  phon_sone_arrays(tot_blocks); // reserve memory for inst_sone & inst_phon
  
//  printf("tot_blocks = %ld\n",tot_blocks);
  
  // MEASURE LEVEL OF SIGNAL FILE AS RMS, ACTIVE SPEECH LEVEL & MAX INSTANT PEAK
  if(!print400_600) 
    printf("The following levels are relative to a full scale sinusoid and do not\ntake any account of the channel calibration levels\n");

  get_levels(stereo_sigfile, stereo_sig_fd, &total_bytes, &sig_len_bytes, &sig_head, sigRMS, sigP56, sigPEAK);

  if(!print400_600){
    printf("\nStereo left  channel:\n");
    printf("SIG InstPeakLevelMeasure   %6.1f dB\n",sigPEAK[0]);
    printf("SIG RMSLevelMeasure        %6.1f dB\n",sigRMS[0]);
    printf("SIG P56LevelMeasure        %6.1f dB\n",sigP56[0]);
		
    if(stereo){
      printf("\nStereo right channel:\n");
      printf("SIG InstPeakLevelMeasure   %6.1f dB\n",sigPEAK[1]);
      printf("SIG RMSLevelMeasure        %6.1f dB\n",sigRMS[1]);
      printf("SIG P56LevelMeasure        %6.1f dB\n",sigP56[1]);
    }
		
    printf("\nSignal calibration levels used are:\n");
    printf("Left  channel: %4d dB\n",sig_cb_val[0]);
    printf("Right channel: %4d dB\n",sig_cb_val[1]);
  } // if(!print400_600)
  // Have now got file 32k fd at start of data (from the last read_header in main() ) and calibration levels
  
  stereo = FALSE; // EACH CHANNEL CALC AS MONO
  
  // Split stereo sig file into 2 separate temporary files.
  // for each channel write mono header
  if((mono_sig_fd[0] = fopen(mono_sig_file[0],"wb")) == NULL){  // wb for writing
    fprintf(stderr,"\n!! error opening temp file %s for writing !!\n",mono_sig_file[0]);
    exit(0);
  }
  
  if((mono_sig_fd[1] = fopen(mono_sig_file[1],"wb")) == NULL){  // wb for writing
    fprintf(stderr,"\n!! error opening temp file %s for writing !!\n",mono_sig_file[1]);
    exit(0);
  }
  
  sig_mono_data_bytes = sig_head.data_bytes/2; // mono data bytes = half stereo data bytes
  sig_head.nchans = 1; // mono
  write_wav_head32k(mono_sig_file[0],mono_sig_fd[0],sig_mono_data_bytes,&sig_head);  // sig_head has been changed to give the right headers
  write_wav_head32k(mono_sig_file[1],mono_sig_fd[1],sig_mono_data_bytes,&sig_head);
  
  sig_nSamples   = sig_mono_data_bytes/2;
  
  if((inData = (short *)malloc(sizeof(short)*sig_nSamples*2)) == NULL){ // array for holding total stereo waveform
    printf("sig malloc error 1\n");
    exit(1);
  }
  
  if((sig_inData_left  = (short *)malloc(sizeof(short)*sig_nSamples)) == NULL){   // array for holding left  channel waveform
    printf("sig malloc error 2\n");
    exit(1);
  }
  if((sig_inData_right = (short *)malloc(sizeof(short)*sig_nSamples)) == NULL){   // array for holding right channel waveform
    printf("sig malloc error 3\n");
    exit(1);
  }
  fread(inData,sizeof(short),sig_nSamples*2,stereo_sig_fd);     // read in whole stereo file
  fclose(stereo_sig_fd);
  
  for (indx=0 ; indx < sig_nSamples ; indx++){
    sig_inData_left[indx]  = inData[indx*2];   // extract left channel
    sig_inData_right[indx] = inData[indx*2+1]; // extract right channel
  }
  
  fwrite(sig_inData_left, SHORTS,sig_nSamples,mono_sig_fd[0]);
  fwrite(sig_inData_right,SHORTS,sig_nSamples,mono_sig_fd[1]);
  fclose(mono_sig_fd[0]);
  fclose(mono_sig_fd[1]);
  
  if(verbose){
    printf("Left  channel now in file mono_left3.wav\n");
    printf("Right channel now in file mono_right3.wav\n");
  }
  
  for ( channel_no = 0 ; channel_no <= 1 ; channel_no++) {
    // read headers leaving mono_sig_fd[channel_no] at start of data
    read_headers(mono_sig_file[channel_no], &mono_sig_fd[channel_no], &total_bytes, &sig_len_bytes, &mono_head[channel_no]);
    if(do_fir[channel_no]){
      if(channel_no==0)printf("FIR filtering left  channel using %s coeffts\n",fir_name[channel_no]);
      if(channel_no==1)printf("FIR filtering right channel using %s coeffts\n",fir_name[channel_no]);
      fir_sub1(mono_sig_file[channel_no], &mono_sig_fd[channel_no], sig_fir_file[channel_no], fir_name[channel_no], &mono_head[channel_no]);
      strcpy(mono_sig_file[channel_no],sig_fir_file[channel_no]); // make the fir filtered file names the current (mono) signal file names
      fclose(mono_sig_fd[channel_no]);
      read_headers(mono_sig_file[channel_no], &mono_sig_fd[channel_no], &total_bytes, &sig_len_bytes, &mono_head[channel_no]);  // fd at start of data area
    } // if(do_fir[channel_no]
    
    // save the start positions of data in signal file (at beginning of data)
    sig_start = ftell(mono_sig_fd[channel_no]);
    if(verbose)printf("sig_start %1d = %d\n",channel_no,sig_start);
    
    // make signal array & read data in		
    if(( sigraw[channel_no] = (short *) malloc(all_sig_used * SHORTS)) == NULL){ 
      fprintf(stderr,"malloc error (sigraw[%1d])\n",channel_no); 
      exit(1);
    }
    
    if((retval = (long)fread(sigraw[channel_no], SHORTS, all_sig_used, mono_sig_fd[channel_no])) != (long)all_sig_used){
      if(ferror(mono_sig_fd[channel_no])) fprintf(stderr,"fread sigraw[%1d] error, retval = %ld instead of %ld\n",channel_no,retval,all_sig_used); 
      if(feof(mono_sig_fd[channel_no]))   fprintf(stderr,"End of file found, fread sigraw[%1d], retval = %ld instead of %ld\n",channel_no,retval,all_sig_used); 
      exit(1);
    }
    
    // copy the signal being measured to an array of doubles with max +- 1.0
    if(( sigraw_f[channel_no] = (double *) malloc(all_sig_used * sizeof(double))) == NULL){
      fprintf(stderr,"malloc error (sigraw_f[%1d])\n",channel_no); 
      exit(1);
    }
    for ( j = 0 ; j < (long)all_sig_used ; j++) sigraw_f[channel_no][j] = (double)sigraw[channel_no][j]/32768.0;
    
    // The signal from start of data to end of required anaysis is in sigraw[] as 16 bit integers & sigraw_f[] as doubles
    // If the portion of the signal to be analysed is offset from the signal start, the portion of the signal between 
    // the start and the offset must be run through the loudness model to allow the loudness to 'build up' as it would
    // in real life.  The part of the signal for which the loudness is displayed starts at
    // sigraw[av_from*32] (shorts) or sigraw_f (doubles) and is sig_used 16bit samples long.
    
    if(verbose) printf("\n\nSAVED WAVEFORM, channel_no = %1d\n\n",channel_no);
    
    if(verbose){
      printf("Calibration of sig file channel %1d is %d\n",channel_no,sig_cb_val[channel_no]);
      printf("calib_scale = %.3f = %.1f dB\n",calib_scale, 20.0*log10(calib_scale));
    }
    
    // CALL LOUDNESS ROUTINE
    // move sig file pointer back to data start for loudness routine
    fseek(mono_sig_fd[channel_no],sig_start,SEEK_SET);
    
    
    
    for ( i = 1 ; i <= CONVLV_PTS ; i++) sp1_loud[i] = sp2_loud[i]= 0.0;  // zero before partly filling sp?_loud with specific loudness
    
    // program goes through st_loudness3 twice, once for each channel
    st_loudness3(channel_no,mono_sig_file[channel_no], bkgfile, sig_cb_val[channel_no], calib_scale, ex_include, av_from, av_to, av_to_flag,
      mono_sig_fd[channel_no], bkg_fd,	bkg_end, monaural, do_scale_sig, do_scale_bkg,
      Nfilename, Nflag,4,ch1_inst_sploud, ch2_inst_sploud);  // number 4 to tell st_loudness3 calling prog is stereo_sig
    fclose(mono_sig_fd[channel_no]);
    
  } // for ( channel_no = 0 ; channel_no <= 1 ; ...
  
  // ch1_inst_sploud[i][j] & ch2_inst_sploud[i][j] are now full, i = 1..N_Es, j = 1,tot_blocks
  
  for ( nblock = 1 ; nblock <= tot_blocks ; nblock++)	{ // go through blocks (time in ms)    //qqq
    mono_sones[0] = mono_sones[1] = 0.0;
    for ( i = 1 ; i <= N_Es ; i++){
      sp1_loud[i] = ch1_inst_sploud[i][nblock] * ESTEP;
      sp2_loud[i] = ch2_inst_sploud[i][nblock] * ESTEP;
      mono_sones[0] += sp1_loud[i]; 
      mono_sones[1] += sp2_loud[i]; 
    }
    if(prt){
      printf("chan1: inst      mono sones = %9.4f  phons = %9.2f\n",mono_sones[0],so2phons(mono_sones[0]));
      printf("chan2: inst      mono sones = %9.4f  phons = %9.2f\n",mono_sones[1],so2phons(mono_sones[1]));
    }
    
    // Now have specific loudness's in sp1_loud & sp2_loud: 
    // they are in sones / 0.25 ERB / try just adding and seeing what level comes out remembering that each separate channel is monaural (obvious really)
    
    /* This bit is OK
    sones = 0.0;
    for ( i = 1 ; i <= N_Es ; i++) sones += sp1_loud[i];
    sones *= ESTEP;
    sones *=2;  // for one channel 'being binaural'
    phons = so2phons(sones);
    printf("chan1  block %5d   sones = %8.4f   phons = %6.2f dB\n",nblock,sones,phons);
    
      sones = 0.0;
      for ( i = 1 ; i <= N_Es ; i++) sones += sp2_loud[i];
      sones *= ESTEP;
      phons = so2phons(sones);
      //  printf("chan2  block %5d   sones = %8.4f   phons = %6.2f dB\n",nblock,sones,phons);
    */
    
    
    // sp1_loud[] & sp2_loud[] hold the original specific loudness values for block nblock
    // that will be inhibited by inhib1[] & inhib2[] calculated later
    for ( i = 1 ; i <= N_Es ; i++){
      if(sp1_loud[i] < 1.0e-13) sp1_loud[i] = 1.0e-13; // to stop problems when dividing in inhib_sp1_loud[i] calc
      if(sp2_loud[i] < 1.0e-13) sp2_loud[i] = 1.0e-13;
    }
    
    if(prt)printf("\nSpecific loudness for Chan1 & Chan2\n\n");
    
    for( i = 1 ; i <= CONVLV_PTS2 ; i++ ) smooth1[i] = smooth2[i] = 0.0;
    
    //------------------------------------------------------------------------------------------
    // Calc gauss filter in 'wrap around' order (Num Rec Ch 13ish)  
    Broad1 = 0.08;        // broader filter
    
    for ( i = 1 ; i <= GAUSS_PTS/2 +1; i++ ){  // i = 1 to 73
      g = (float)(i - 1)*0.25;    // 0.25 = ESTEP
      abs_g = fabs(g);
      temp = Broad1 * abs_g;
      gauss_wf[i] = exp(-temp*temp);
    }
    for ( i = 1 ; i <= GAUSS_PTS/2 ; i++ ){  // 146-i = 182 to 361  2 -> 361   180 -> 182
      g = (float)(i)*0.25; // ESTEP
      abs_g = fabs(g);
      temp = Broad1 * abs_g;
      gauss_wf[146 - i] = exp(-temp*temp);
    }
    for ( i = 1 ; i <= CONVLV_PTS; i++ ) gauss_wf_sav[i] = gauss_wf[i];
    
    //  for(i = 1 ; i <= GAUSS_PTS ; i++) printf("i %4d:  %8.5f\n",i,gauss_wf[i]);
    
    // Smear the specific loudness arrays with the gaussian(Broad) equation  
    
    dconvlv(sp1_loud,CONVLV_PTS,gauss_wf,GAUSS_PTS,isign,smooth1);
    for ( i = 1 ; i <= CONVLV_PTS; i++ ) gauss_wf[i] = gauss_wf_sav[i];  // restore gauss_wf[]
    dconvlv(sp2_loud,CONVLV_PTS,gauss_wf,GAUSS_PTS,isign,smooth2);
    
    
    // The specific loudness data is in sp1_loud[i] & sp2_loud[i] i = 1...N_Es (1 to 372 points)
    // for convlv( ) it need to be 2^n long so copy into 512 point float array
    // the gauss_wt is 361 points long,
    
    
    // calc inhib1[] & inhib2[]
    for ( i = 1 ; i <= N_Es; i++ ){
      inhib1[i] = 2.0/(1.0+pow(1.0/cosh(smooth2[i]/smooth1[i]),inhib_P));
      inhib2[i] = 2.0/(1.0+pow(1.0/cosh(smooth1[i]/smooth2[i]),inhib_P));
    }
    
    //  printf("\nsp1_loud[], inhib1[], sp2_loud[] & inhib2[]\n\n");
    //  for ( i = 1 ; i <= N_Es; i++ ) printf("%4d: %8.4f %8.6f   %8.4f %8.6f\n",i,sp1_loud[i],inhib1[i],sp2_loud[i],inhib2[i]);
    
    if(prt) printf("inhibited sones:  freq Hz       channel 1        channel 2\n");
    
    inhib_sones1 = inhib_sones2 = 0.0;
    Ecounter = 0; // for keeping track of howmany Es we've gone through
    for ( i = 1 ; i <= N_Es; i++ ){
      inhib_sp1_loud[i] = sp1_loud[i]/inhib1[i];
      inhib_sones1 += inhib_sp1_loud[i];
      inhib_sp2_loud[i] = sp2_loud[i]/inhib2[i];
      inhib_sones2 += inhib_sp2_loud[i];
      
      Ecounter++;  // goes from 1 to 156 ??
      if(prt && inhib_sp1_loud[i] > 0.0000001) printf("                %7.1f        %10.7f       %10.7f\n",E_frqHz[Ecounter],inhib_sp1_loud[i],inhib_sp2_loud[i]);
    }
    
    bin_sones = inhib_sones1 +  inhib_sones2;
    bin_phons = so2phons(bin_sones);
    
    //  printf("%6ld: inst loudness  %9.3f sones,  inst loudness level =%6.1f phons\n",nblock,bin_sones,bin_phons);
    
    
    // nblock goes from 1 to tot_blocks
    // copy inhib_sones1 into ch_inst_sone[0][j] where j = nblock-1 ie j goes from 0 to tot_block-1
    
    ch_inst_sone[0][nblock-1] = inhib_sones1;    // left  channel
    ch_inst_sone[1][nblock-1] = inhib_sones2;    // right channel
    
    // DO BINAURAL STUFF FOR BLOCK j to get ch_inst_sone[channel_no][j] (channel_no = 0 for channel 1 & channel_no = 1 for channel 2)
  } //for ( nblock = 1 ; nblock < tot_blocks
  
  //for ( j = 0 ; j < tot_blocks-1 ; j++)	printf("%6d:  %9.3f    %9.3f\n",j+1,ch_inst_sone[0][j],ch_inst_sone[1][j]);
  // printf("exit\n");
  //exit(0);
  
  // PRINT OUT SONES / PHONS
  
  for ( channel_no = 0 ; channel_no <= 1 ; channel_no++){
    // This loops calcs the inst, ave1 & ave2 for each channel separately (mono)
    for ( j = 0 ; j < tot_blocks-1 ; j++)	{
      ch_inst_phon[channel_no][j] = so2phons(ch_inst_sone[channel_no][j]);
      // 1st average (ATTACK1 / RELEASE1)
      if(ch_inst_sone[channel_no][j] >= mean1_sone[channel_no])
        mean1_sone[channel_no] =  ATTACK1*ch_inst_sone[channel_no][j]+(1.0-ATTACK1)*mean1_sone[channel_no];
      else
        mean1_sone[channel_no] = RELEASE1*ch_inst_sone[channel_no][j]+(1.0-RELEASE1)*mean1_sone[channel_no];
      ch_ave1_sone[channel_no][j] = mean1_sone[channel_no];
      ch_ave1_phon[channel_no][j] = so2phons(mean1_sone[channel_no]);
      
      // 2nd average (ATTACK2 / RELEASE2 type) on 1st average
      if(mean1_sone[channel_no] >= mean2_sone[channel_no])
        mean2_sone[channel_no] =  ATTACK2*mean1_sone[channel_no]+(1.0-ATTACK2)*mean2_sone[channel_no];
      else if(mean1_sone[channel_no] < mean2_sone[channel_no])
        mean2_sone[channel_no] = RELEASE2*mean1_sone[channel_no]+(1.0-RELEASE2)*mean2_sone[channel_no];
      ch_ave2_sone[channel_no][j] = mean2_sone[channel_no];
      ch_ave2_phon[channel_no][j] = so2phons(mean2_sone[channel_no]);
    } // for ( j = 0 ; j < tot_blocks ; ...
  } // for ( channel_no = 0 ; channel_no <= 1 ; ...
  


  // Now to combine the  two mono signals to give the stereo loudness ADDING THE TWO MONO ave1 LOUDNESSES TO GET THE stereo ave1 & similarly for ave2
   
  for ( j = 0 ; j < tot_blocks-1 ; j++)	{
    stereo_inst_sone[j] = ch_inst_sone[0][j] + ch_inst_sone[1][j];
    stereo_inst_phon[j] = so2phons(stereo_inst_sone[j]);
    stereo_ave1_sone[j] = ch_ave1_sone[0][j] + ch_ave1_sone[1][j];
    stereo_ave1_phon[j] = so2phons(stereo_ave1_sone[j]);
    stereo_ave2_sone[j] = ch_ave2_sone[0][j] + ch_ave2_sone[1][j];
    stereo_ave2_phon[j] = so2phons(stereo_ave2_sone[j]);
  }// j=0 ; j < tot_blocks
  
#if 0
  printf("\n\nLEFT CHANNEL (MONO)\n\n");
  printf("  Time   instantaneous |      average 1   |     average 2\n");
  printf("   ms    sones   phons |    sones   phons |   sones   phons\n");
  for ( j = av_from ; j < tot_blocks-1 ; j++){ 
    printf("%5d: %7.2f  %6.1f |  %7.2f  %6.1f | %7.2f  %6.1f\n",j,ch_inst_sone[0][j],ch_inst_phon[0][j],ch_ave1_sone[0][j],ch_ave1_phon[0][j],ch_ave2_sone[0][j],ch_ave2_phon[0][j]);
    if(ch_ave1_sone[0][j] > max_av1_sones) max_av1_sones = ch_ave1_sone[0][j];
    if(ch_ave1_phon[0][j] > max_av1_phons) max_av1_phons = ch_ave1_phon[0][j];
    if(ch_ave1_sone[0][j] > max_av2_sones) max_av2_sones = ch_ave2_sone[0][j];
    if(ch_ave1_phon[0][j] > max_av2_phons) max_av2_phons = ch_ave2_phon[0][j];
  }
  printf("\nmax: average1 sones      %8.2f %7.2f",max_av1_sones,max_av1_phons);
  printf("\nmax: average2 sones      %8.2f %7.2f\n",max_av2_sones,max_av2_phons);
  
  max_av1_sones = -100.0;
  max_av2_sones = -100.0;
  max_av1_phons = -100.0;
  max_av2_phons = -100.0;
  
  printf("\n\nRIGHT CHANNEL (MONO)\n\n");
  printf("  Time   instantaneous |      average 1   |     average 2\n");
  printf("   ms    sones   phons |    sones   phons |   sones   phons\n");
  for ( j = av_from ; j < tot_blocks-1 ; j++){ 
    printf("%5d: %7.2f  %6.1f |  %7.2f  %6.1f | %7.2f  %6.1f\n",j,ch_inst_sone[1][j],ch_inst_phon[1][j],ch_ave1_sone[1][j],ch_ave1_phon[1][j],ch_ave2_sone[1][j],ch_ave2_phon[1][j]);
    if(ch_ave1_sone[1][j] > max_av1_sones) max_av1_sones = ch_ave1_sone[1][j];
    if(ch_ave1_phon[1][j] > max_av1_phons) max_av1_phons = ch_ave1_phon[1][j];
    if(ch_ave1_sone[1][j] > max_av2_sones) max_av2_sones = ch_ave2_sone[1][j];
    if(ch_ave1_phon[1][j] > max_av2_phons) max_av2_phons = ch_ave2_phon[1][j];
  }
  printf("\nmax: average1 sones      %8.2f %7.2f\n",max_av1_sones,max_av1_phons);
  printf("\nmax: average2 sones      %8.2f %7.2f\n",max_av2_sones,max_av2_phons);
#endif
 
      max_av1_sones = -100.0;
      max_av2_sones = -100.0;
      max_av1_phons = -100.0;
      max_av2_phons = -100.0;

  if(!print400_600){
    printf("\n\nBOTH CHANNELS (STEREO)\n\n");
	  printf("  Time   instantaneous |      average 1   |     average 2\n");
  	printf("   ms    sones   phons |    sones   phons |   sones   phons\n");
    for ( j = av_from ; j < tot_blocks-1 ; j++){
  		printf("%5d: %7.2f  %6.1f |  %7.2f  %6.2f | %7.2f  %6.1f\n",j,stereo_inst_sone[j],stereo_inst_phon[j],stereo_ave1_sone[j],stereo_ave1_phon[j],stereo_ave2_sone[j],stereo_ave2_phon[j]);
  	  if(stereo_ave1_phon[j] > max_av1_phons) max_av1_phons = stereo_ave1_phon[j];
      if(stereo_ave2_phon[j] > max_av2_phons) max_av2_phons = stereo_ave2_phon[j];

   	  if(stereo_ave1_sone[j] > max_av1_sones) max_av1_sones = stereo_ave1_sone[j];
      if(stereo_ave2_sone[j] > max_av2_sones) max_av2_sones = stereo_ave2_sone[j];

    }
//  printf("\nmax: average1 phons  %7.2f   average1 sones   %8.2f",max_av1_sones,max_av1_phons);
//  printf("\nmax: average2 phons  %7.2f   average2 sones   %8.2f",max_av2_sones,max_av2_phons);
    
  	printf("                       |                  |                \n");
    printf("         instantaneous |      average 1   |     average 2\n");
  	printf("                       |                  |                \n");
  	printf("                       |    sones   phons |   sones   phons\n");
    printf("maximum:               |  %7.2f %7.1f | %7.2f %7.1f \n",max_av1_sones,max_av1_phons,max_av2_sones,max_av2_phons);

    
    
//  printf("\nmax:             sones  %7.2f   sones   %8.2f",max_av1_sones,max_av2_sones);
    
    printf("\n");
  } // if(!print400_600)
  else if(print400_600){
    printf("200\n");
    for ( j = 400 ; j < 600 ; j++){
  		printf("%5d, %6.2f\n",j,stereo_ave1_phon[j]);
    }
  } // else if(print400_600)

} // end of main
//-------------------------------------------------------------------------------
int get_fn_nums(char *str1, char* filename ,int *number, short stereo)
{
		// see if str1 is in filename	& get clock freq or calibration level
		char *pdest;
    int result, flag = TRUE;
    
    pdest = strstr(filename,str1);
    if(pdest != NULL){
      result = pdest - filename + strlen(str1); // position directly after str1
      if(verbose) printf("%s found at index %d in %s\n",str1,result,filename);
    } else {
      return FALSE;
      // FOR THE SAMPLE FREQ, WILL USE THAT READ FROM THE WAV HEADER
    }
  if (verbose) printf("yyyy4\n");
    //read number(s) in filename name if the str1 is found
    //	if(flag) {
    if(!strcmp("SfHz(",str1)) sscanf(&filename[result],"%d",&number[0]); // clock
    if(!strcmp("CdB(",str1)) {
      if(!stereo) {
        sscanf(&filename[result],"%d",&number[0]); // mono
        if(verbose) printf("get_fn_nums: mono number = %d\n",number[0]);
      } else if (stereo) {
        sscanf(&filename[result],"%d,%d",&number[0],&number[1]); //  stereo
        if(verbose) printf("get_fn_nums: stereo number = %d, number2 = %d\n",number[0],number[1]);
      }
    }
    //	}
    return TRUE;
}
//-------------------------------------------------------------------------------
void print_format(struct formathead *fh)
{
		printf("clock Hz                        = %ld\n",fh->clockHz);
    printf("nchans (1 or 2)                 = %d\n",fh->nchans);
    printf("bytes/sample (2 mono, 4 stereo) = %d\n",fh->bytes);
    
    //	USHORT w_format;    /* 16 bit number = 1 for PCM */
    //	USHORT nchans;      /* 1 or 2 channels */
    //	ULONG  clockHz;     /* sampling clock */
    //	ULONG  bytes_sec;   /* clockHz*nchans*bytes_sample */
    //	USHORT bytes;       /* 2=16 bit mono, 4 = 16 bit stereo */
    //	USHORT bits_sample; /* 16 for us */
    //  ULONG data_bytes;
}

//-------------------------------------------------------------------------------

void new_nameHz(char *str1, char* infilename, char* newname)
{
		// If changing the resampled filename know "SfHz(" is in there already but pick up position again
		char *pdest, c32000[] = {"32000"};
    int i, result, number, flag = TRUE;
    
    strcpy(newname,infilename);
    pdest = strstr(newname,str1);
    if(pdest != NULL){
      result = pdest - newname + strlen(str1); // position directly after str1
      printf("new_nameHz: %s found at index %d in %s\n",str1,result,newname);
    } else {
      printf("new_nameHz: %s not found in %s\n",str1,newname);
      flag = FALSE;
    }
    //read number in newname name
    
    if(flag){
      sscanf(&newname[result],"%d",&number);
      if(number > 9999 && number < 100000) { // 5 digit number
        for(i=0 ; i < 5 ; i++) newname[result+i] = c32000[i];
      } // if 5 digit number
      else if(number < 10000 && number > 999) { // 4 digit number (8000 ?) need to move part of name along
        // move part of name after CdB( along one character to fit 5 digits 32000 in place of 4 digits
        printf("result %d, strlen %d\n",result,strlen(newname));
        for( i = (int)strlen(newname) ; i >= result ; i-- )
          newname[i+1] = newname[i];
        for(i=0 ; i < 5 ; i++) newname[result+i] = c32000[i];
      } // 4 digit number
    } // if (flag)
}
//-------------------------------------------------------------------------------

int add2filename(char* filename, char* to_add, FILE *fd, short copy, char* c_orig)
{
		// If filename is eg  "abcd.wav"  and the string in to_add is "CdB(100)" will change filename to abcdCdB(100).wav
		// If filename doesn't end in .wav just adds string to_add to the end of filename e.g. abcd + CdB(100) --> abcdCdB(100)
		char dot_wav[] = {".wav"};
    char ctemp[256], c_system[600];
    char *posn;
    int iposn, retval, ret;
    
    
    // save old name
    strcpy(ctemp,filename);
    
    posn = strstr(filename,dot_wav);
    if(posn == NULL) {
      printf("%s not found in %s\n",dot_wav,filename);
      strcat(filename,to_add);
      
    } else {
      if(verbose) printf("filename %d, posn %d, strlen(dot_wav) %d\n",filename,posn,strlen(dot_wav));
      iposn = posn - filename;
      if(verbose) printf("%s found in %s at position %d\n",dot_wav,filename,iposn);
      filename[iposn] = '\0';
      strcat(filename,to_add);
      strcat(filename,dot_wav);
    }
    
    if(access(filename,0) == 0) {
      fprintf(stderr,"Cannot rename %s \nFile %s already exists \n",ctemp,filename);
      exit(0);
    }
    
    // need to close filename, rename it then reopen it at the start of the data (done in main)
    fclose(fd);
    
    if(!copy){
      if((retval = rename(ctemp,filename)) != 0){
        if(verbose) fprintf(stderr,"addfilename: Problem with renaming file %s to %s   rename() retval = %d\n",ctemp,filename,retval);
        exit(0);
      }
      
      if(retval == 0) ret = TRUE;
      else ret = FALSE;
      return ret;
    } else if (copy){
      strcpy(c_system,"copy ");
      strcat(c_system,c_orig);
      strcat(c_system," ");
      strcat(c_system,filename);
      printf("C_SYSTEM %s",c_system);
      
      system(c_system);
      return 1;
    }
    fprintf(stderr,"add2filename: Should not get here, exiting\n\n");
    exit(1);
}
//-------------------------------------------------------------------------------

int  add_sf(char* filename, int sf, FILE **fd)
{
		// make sf (eg 22050) into string "SfHz(22050)" then add to end of filename (before .wav if present)
		
		char ch, buff[20]; // 19 char + null?
    int ret;
    short copy = FALSE;
    
    sprintf(buff,"SfHz(%d)",sf);
    
    do{
      fprintf(stderr,"\nWould you like to rename filename %s \nby adding %s  (y/n) ?  ",filename,buff);
      ch = tolower(getchar());
    } while (ch != 'y' && ch != 'n');
    fflush(stdin); // FLUSH KEYBOARD
    if(ch == 'n') {
      return FALSE; // name not changed
    }
    else if(ch == 'y')
      copy = FALSE;
    
    ret = add2filename(filename,buff,*fd, copy, buff); // copy always FALSE, 2nd filename (now buff) for compatability
    return ret;
}
//-------------------------------------------------------------------------------

int  add_cb(char* filename, int* cb, FILE **fd, short stereo) // use for mono, stage1d.c version
{
		// add a calibration value to the end of the filename, the form for mono is CdB(100)
		
		char ch;
    char buff[20], c_orig[256]; // 19 char + null?
    int ret;
    short copy = FALSE;
    
    //	printf("add_cb: filename passed in %s\n",filename);
    strcpy(c_orig,filename);
    if(!stereo)
      sprintf(buff,"CdB(%d)",cb[0]);
    else
      sprintf(buff,"CdB(%d,%d)",cb[0],cb[1]);
    
    do{
      fprintf(stderr,"\nWould you like to rename file %s \nby adding %s (y/n)? ",filename,buff);
      ch = tolower(getchar());
    } while (ch != 'y' && ch != 'n');
    fflush(stdin); // FLUSH KEYBOARD
    if(ch == 'n') {
      return FALSE; // name not changed
    }	else if(ch == 'y') // y rename
      
      ret = add2filename(filename,buff,*fd, copy, c_orig);  // 2nd filename for copying
    return ret;
}
//-------------------------------------------------------------------------------
int  swap_cb(char* filename, int *cb, FILE **fd, short stereo) // already had CdB(??), remove this and add new Cdb(??) to end
{
		
		char ch, buff[20], CdB[] = {"CdB("};
    char c_orig[256], *posn;
    int ret, iposn, iposn1, i, j;
    short copy = FALSE;
    
    //	printf("swap_cb: filename passed in %s\n",filename);
    strcpy(c_orig,filename); // save filename 
    posn = strstr(filename,CdB);	// find position of CdB( already in filename
    if(posn == NULL) {
      printf("%s not found in %s\n",CdB,filename);
      return (add_cb(filename, cb, fd, stereo));
    }
    iposn = posn - filename;
    iposn1 = iposn;
    do{
    }while (filename[++iposn1] != ')' );  // look for 1st right bracket after CdB(
    
    j=iposn+strlen(filename)-iposn1;
    
    for ( i = iposn; i <= j; i++ )
      filename[i] = filename[i+iposn1-iposn+1];
    
    if(!stereo)
      sprintf(buff,"CdB(%d)",cb[0]);
    else if(stereo)
      sprintf(buff,"CdB(%d,%d)",cb[0],cb[1]);
    
    do{
      fprintf(stderr,"\nWould you like to rename the old filename (r)\n%s\nby adding %s to\n%s\n",c_orig,buff,filename);
      fprintf(stderr,"or would you rather copy (c)\n%s\n",c_orig);
      ch = tolower(getchar());
    } while (ch != 'r' && ch != 'c');
    fflush(stdin); // FLUSH KEYBOARD
    
    //	if(ch == 'n') {
    //		strcpy(filename,c_orig);
    //		return FALSE; // name not changed
    //	} else 
    
    if(ch == 'c')	copy = TRUE;
    else if(ch == 'r') copy = FALSE;	
    
    ret = add2filename(filename,buff,*fd, copy, c_orig); // c_orig is original filename
    return ret;
}		
//-------------------------------------------------------------------------------
void only_rename(char* orig, char* tempname, char* newfilename) // assumes filename is closed
{
		
		int retval;
    
    fprintf(stderr,"What would you like to call the new file which has been changed from\n%s\n",orig);
    fprintf(stderr,"to temporary file %s ?\n",tempname);
    fgets(newfilename,254,stdin);
    newfilename[strlen(newfilename)-1] = '\0';
    if(access(newfilename,0) == 0) { // see if new name already exists
      fprintf(stderr,"Cannot rename %s \nFile %s already exists \n",tempname,newfilename);
      exit(0);
    }
    if((retval = rename(tempname,newfilename)) != 0){
      fprintf(stderr,"Problem with renaming file %s to %s   rename() retval = %d\n",tempname,newfilename,retval);
    }
}
//-------------------------------------------------------------------------------

void phon_sone_arrays(long tot_blocks)
{
  // now we know total_blocks, reserve memory
  int i;
  
  for ( i = 0 ; i <= 1 ; i++){ // Allocate memory for both channels
    ch_inst_sone[i]  = (double *)malloc(tot_blocks * sizeof(double)); 
    ch_ave1_sone[i]  = (double *)malloc(tot_blocks * sizeof(double)); 
    ch_ave2_sone[i]  = (double *)malloc(tot_blocks * sizeof(double)); 
    ch_inst_phon[i]  = (double *)malloc(tot_blocks * sizeof(double)); 
    ch_ave1_phon[i]  = (double *)malloc(tot_blocks * sizeof(double)); 
    ch_ave2_phon[i]  = (double *)malloc(tot_blocks * sizeof(double));
  }
  
  stereo_inst_sone = (double *)malloc(tot_blocks * sizeof(double));
  stereo_ave1_sone = (double *)malloc(tot_blocks * sizeof(double));
  stereo_ave2_sone = (double *)malloc(tot_blocks * sizeof(double));
  
  stereo_inst_phon = (double *)malloc(tot_blocks * sizeof(double));
  stereo_ave1_phon = (double *)malloc(tot_blocks * sizeof(double));
  stereo_ave2_phon = (double *)malloc(tot_blocks * sizeof(double));
}
//--------------------------------------------------------------

void check_calib_txt(char* calib_txt)
{
  char *pdest;
  int flag;
  
  flag = TRUE;
  pdest = strchr( calib_txt, '(' );
  if(pdest == NULL) flag = FALSE;
  if(flag) {
    pdest = strchr( calib_txt, ',' );
    if(pdest == NULL) flag = FALSE;
  }
  if(flag) {
    pdest = strchr( calib_txt, ')' );
    if(pdest == NULL) flag = FALSE;
  }	
  if(!flag){
    printf("use -c (xx,yy)    e.g.    -c (85,90)    N.B. no spaces in (xx,yy)\n\n"); 
    exit(0);
  }
}
//-------------------------------------------------------------------------------
void fir_filenames(char *firnames, short do_fir[])
{
  void firname_err(char ch);
  int open_br, close_br, comma;
  char *pdest;
  
  if(verbose) printf("in fir_filenames:  firnames is %s\n",firnames);

  if(do_fir[0]){
    pdest = strchr(firnames,'(');
    if(pdest == NULL) {firname_err('('); exit(0);}
    open_br = pdest - firnames + 1;
    
    pdest = strchr(firnames,',');
    if(pdest == NULL) {firname_err(','); exit(0);}
    comma = pdest - firnames + 1;
    
    pdest = strchr(firnames,')');
    if(pdest == NULL) {firname_err(')'); exit(0);}
    close_br = pdest - firnames + 1;
    
    strncpy(fir_name[0],&firnames[open_br],comma-open_br-1);
    fir_name[0][comma-open_br-1] = '\0';
    
    strncpy(fir_name[1],&firnames[comma],close_br-comma-1);
    fir_name[1][close_br-comma-1] = '\0';

    if(verbose) printf("in fir_filenames:  firnames is %s\n",firnames);
  
    if(!strcmp(fir_name[0],"none")) do_fir[0] = FALSE;
    if(!strcmp(fir_name[1],"none")) do_fir[1] = FALSE;
  }
}	
//----------------------------------------------------------------------------------------
void firname_err(char ch)
{
  if(ch == '(') printf("Command line FIR file names must start with '%c'\n\n",ch);
  if(ch == ',') printf("Command line FIR file names must be comma separated '%c'\n\n",ch);
  if(ch == ')') printf("Command line FIR file names must end with '%c'\n\n",ch);
  printf("eg   -F (xxx,yyy)\n\n");
}
//-------------------------------------------------------------------------------

void info(void)
{
  
  printf("TVLBIN -i sig_file  ..... \n\n");
  printf("-i sig_file: A 16-bit WAV stereo signal file sampled at 32k is expected\n");
  
  printf("-x dB: by default all spectral components more than 60-dB below the maximum are\n");
  printf("       discarded before calc. the excitation pattern. Change with e.g.  -x 80.0\n\n");
  
  printf("-c (xx,yy)   set left channel signal calibration to xx dB, right channel yy dB\n\n");
  
  printf("-F (xxx,yyy) fir coefft files xxx for left channel, yyy for right channel\n");
  printf("             eg. -F (ff.32k,ff.32k)\n");
  printf("             NOTE: the default is diffuse field filtering for both channels\n");
  
  printf("-b: beginning time in ms from which the loudness is to be estimated\n");
  printf("-e: end time in ms to which the loudness is to be estimated\n");
  printf("-v: turns on verbose mode\n");
  printf("-I: gives this information\n");
  
  printf("\n");
  printf("simple use, calibration level for left channel 90 & for right channel 100 dB\n");
  printf("TVLBIN -i 1k2.wav -c (100,90) > 1k2.out\n\n");
  printf("to prefilter both channels using different coefficient files :\n");
  printf("df.32k for the left channel and ff.32k for the right channel\n");
  printf("with the calibration levels 100 dB left channel & 95 dB right channel\n");
  printf("sending the output to file 1k2.out, use:\n\n");
  printf("TVLBIN -i 1k2.wav -F (df.32k,ff.32k) -c (100,90) > 1k2.out\n\n");
}
