/* wave6.h */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h> /* file status: for finding out file length */
#include <sys/types.h>
#include "stdefs.h"

#define  C1    		24.673
#define  C2		4.368
#define  C3  		(2302.6/(C1 * C2))
#define  p51_1k  	(4.0 * 1000.0/(C1*(C2 + 1.0)))

#define ESTART  1.75
//#define ESTART  1.84
  // centres one of the ERBs at 1.000 kHz
#define EEND   39.0
#define ESTEP   0.25
#define N_ERBS ((EEND-ESTART)/ESTEP + 1) // 150
#define N_Es            (EEND*4)         // 156
/*
    N_Es = 156, number of 1/4 ERBS for saving 'loudness spectrum' 
   (specific loudness vs ERB ) every ms
*/


#define HAMM_CORR 	4.0  // Hamming correction drops level by 4 dB, not used

#define HANN_CORR 	3.32  // Hanning correction drops level by 3.32 (originally 4.26) dB,        pre  11/9/2003  reinstated
//#define HANN_CORR 	5.52        // Hanning correction drops level by 5.52 dB,                      post 11/9/2003

//#define constant 0.04738978   //                                                                 pre - 11/9/2003  reinstated
//#define constant 0.0398786141   //                                                                 post 11/9/2003 
/*
post 11/9/2003
using constant = 0.039878614 for HANN_CORR = 5.52 which gives
an excitation level of 40.00 dB for a 40 dB 1k free-field binaural tone
	d3 -i 1k100.wav -c  40 -F ff.32k -->  1.0000000 sones
  d3 -i 1k100.wav -c  50 -F ff.32k -->  2.0537 sones
  d3 -i 1k100.wav -c  60 -F ff.32k -->  4.0023 sones
  d3 -i 1k100.wav -c  70 -F ff.32k -->  7.6798 sones
  d3 -i 1k100.wav -c  80 -F ff.32k --> 14.9323 sones
  d3 -i 1k100.wav -c  90 -F ff.32k --> 30.5940 sones
  d3 -i 1k100.wav -c 100 -F ff.32k --> 64.1554 sones
where 1k100.wav is a 200 ms full scale 1k sinusoid with 10 ms ramps
*/


// original values of attack & release alphas now used

//                        Calc time in ms = -0.001/log(1.0 - RELEASE2) *1000
#define ATTACK1   0.045          //  
#define RELEASE1  0.033           //  
#define ATTACK2   0.01           //  
#define RELEASE2  0.00133         //  
