// readfile.h

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <io.h>

#include "nrutil.h"
#include "wave6.h"
#include "stdefs.h"

#define	SHORTS		sizeof(short)

int  getopt(int argc, char *argv[], char *optionS);
int get_fn_nums(char *str1, char* filename ,int *number, short stereo);
void new_nameHz(char *str1, char* infilename, char* newname);
int bg_resample(char* insfname, FILE **infd, char* outsfname, FILE *outfd, ULONG data_bytes, struct formathead *fh);
int read_headers(char* filename, FILE **fd, ULONG *total_bytes, ULONG *data_chunk, struct formathead *fh);
void print_format(struct formathead *fh);
void write_wav_head32k(char* filename, FILE *outfd, ULONG data_bytes, struct formathead *fh);

void read_riff_head(char* filename, ULONG *total_bytes, FILE *fd);
void read_head(char* chunk_name,ULONG *chunk_bytes, FILE *fd);
void read_format(ULONG chunk_bytes, FILE *fd, struct formathead *fh);
void read_data16(ULONG chunk_bytes, FILE *fd);
void read_bits(ULONG chunk_bytes, FILE *fd);
void info(void);

void realft(double* data, long n, int isign);
void scalefft(double *rwave, long npts, double dBmax, long ndata);
void calc_ex(double *Esig, double *compfq, double *sig_int, long ncomps, double *erbdB);
void av_sones(double sones, double frame_ms, double *max1, double *max2, double *min1,
		double *min2, short *first_time, long block, long av_from, short sig_end);
double ex_table(double frqHz);
double erbtofq(double E);
double fqtoerb (double fq);
double calc_K(double frqkHz);
double alpha100(double G_dB);
double Btable(double alpha);
double so2phons(double sones);
void only_rename(char* orig, char* tempname, char* newfilename);
int scalewav(char* filename, FILE **fd, char* temp_scale_file, FILE* tempfile_fd, double dB, struct formathead *fh);

int  add_sf(char* filename, int sf, FILE **fd);
double GetDouble(char *title, double deflt, char *help);
int add_cb(char* filename, int *cb, FILE **fd, short stereo);
int add_cb2(char* filename, int *cb, FILE **fd); // use for stereo
int  swap_cb(char* filename, int *cb, FILE **fd, short stereo); // already had CdB(??), remove this and add new Cdb(??) to end

void loudness(char* sigfile, char* bkgfile, double dBmax, double calib_scale, double ex_include, ULONG av_from, ULONG av_to,
							short av_to_flag, FILE *sig_fd, FILE *bkg_fd,	short bkg_end, short monaural, short do_scale_sig, short do_scale_bkg,
							char* Nfilename, short Nflag, FILE **N_fd, short loud_type);

//st_ prefix for stereo 
void st_loudness(long channel_no,char* sigfile, char* bkgfile, double dBmax, double calib_scale, double ex_include, ULONG av_from, ULONG av_to,
							short av_to_flag, FILE *sig_fd, FILE *bkg_fd,	short bkg_end, short monaural, short do_scale_sig, short do_scale_bkg,
							char* Nfilename, short Nflag, short loud_type);
void st_loudness3(long channel_no,char* sigfile, char* bkgfile, double dBmax, double calib_scale, double ex_include, ULONG av_from, ULONG av_to,
							short av_to_flag, FILE *sig_fd, FILE *bkg_fd,	short bkg_end, short monaural, short do_scale_sig, short do_scale_bkg,
							char* Nfilename, short Nflag, short loud_type, double **ch1_inst_sploud, double **ch2_inst_sploud);
void get_levels(char* sigfile, FILE *sig_fd, ULONG *total_bytes, ULONG *sig_len_bytes, struct formathead *sig_head,
								double *RMS, double *P56, double *PEAK);
void fir_sub(char* inputname, FILE **reading_from, char* temp_fir_file, FILE* tempfile_fd, char* fir_name, struct formathead *fh);
//fir_sub1 fo stereo
void fir_sub1(char* inputname, FILE **reading_from, char* temp_fir_file, char* fir_name, struct formathead *fh);
void phon_sone_arrays(long tot_blocks);
void init_inst(long tot_blocks);
void check_calib_txt(char* calib_txt);
void fir_filenames(char *firnames, short do_fir[]);
