

// st_p_subs3.c   for TVLBIN.c   new so2phons for binaural stuff

#include "wave6.h"

#if 0
TEST MAIN COMMENTED OUT
----------------------------------------------------------------
/*
ex_table(double frqHz);
alpha100(double G_dB);
double Btable(double alpha);
double calc_K(double freqkHz);
double so2phons(double sones);
double lin_int(double *yy,double *xx, double x,unsigned long n)
void locate(double *xx,unsigned long n, double x,unsigned long *j)
double fqtoerb (double fq)
double erbtofq(double E)
int power(int x,int n)
void scalefft(double *rwave, long npts, double dBmax, long ndata)
void calc_ex(double *Eint, double *compfq, double *sig_int, long ncomps, double *erbdB)
void av_sones(double sones, double frame_ms,double *max1, double *max2,
double *min1, double *min2, short *first_time, long block,long av_from, short sig_end)
void info(void)
*/


void main()
{
  double ex_table(double frqHz);
  double alpha100(double G_dB);
  double Btable(double alpha);
  double calc_K(double freqkHz);
  double so2phons(double sones);
	
  double frqHz, G_dB, alpha, kHz, sones;
	
  /*  for (frqHz = 0.0 ; frqHz <= 750.0 ; frqHz += 50.0)
	printf("%6.1f:   %7.2f\n",frqHz,ex_table(frqHz));
	
	 for(G_dB = 0.0 ; G_dB >= -65.0 ; G_dB -= 5.0)
	 printf("%6.1f:   %7.5f\n",G_dB,alpha100(G_dB));
	 
		for (alpha = 0.01 ; alpha <= 0.9205 ; alpha += 0.01)
    printf("%6.2f:   %17.5f\n",alpha,Btable(alpha));
		
		 for ( kHz = 0.0 ; kHz <= 1.0 ; kHz += 0.05 )
		 printf("%6.2f:   %17.5f\n",kHz,10.0*log10(calc_K(kHz)));
	*/
  for ( sones = 10.0 ; sones <= 30.0 ; sones += 1. )
    printf("%6.2f:   %6.2f\n",sones,so2phons(sones));
}
----------------------------------------------------------------------
END OF COMMENTED OUT TEST MAIN
#endif


/* known arrays xx[1..N] & yy[1..N], returns interpolated value of y for x
if x is out of range, returns yy[1] or yy[N] */

double lin_int(double *yy,double *xx, double x,unsigned long n)
{
	/*  Numerical Recipes  page 98 */
  void locate(double *xx,unsigned long n, double x,unsigned long *j);
  unsigned long j;
  
  locate(xx,n,x,&j);
  if(j < 1){
    return(yy[1]);
  }else if(j >= n){
    return(yy[n]);
  }else{
    return(yy[j]+(yy[j+1]-yy[j])*(x-xx[j])/(xx[j+1]-xx[j]));
  }
}
/*-------------------------------------------------------------*/

/* Given an array xx[1..n] and a value x, returns a value j such that x is
between xx[j] ans xx[j+1], j=0 or j=n indicates x is out of range */

void locate(double *xx,unsigned long n, double x,unsigned long *j) /*  Numerical Recipes  page 98 */
{
  int ascnd;
  unsigned long ju,jl,jm;
  
  jl = 0;
  ju = n + 1;
  ascnd=xx[n] > xx[1];
  while(ju-jl > 1) {
    jm = (ju + jl) >> 1;
    if((x > xx[jm]) == ascnd)
      jl = jm;
    else
      ju = jm;
  }
  *j = jl;
  
}

/*---------------------------------------------------------------*/
double ex_table(double frqHz)
{ 
/* Table of internal excitation levels at each Abs threshold in dB
vs frequency in Hz  - only for freqs up to 500 Hz
Above 500 Hz it's 3.63
	*/
  double lin_int(double *yy,double *xx, double x,unsigned long n);
	
  unsigned long n_thr = 35;
  double Hz[35] = {
    0.,
			50.,     63.,    80.,   100.,    125.,   160.,  200.,   250.,
			315.,    400.,   500.,   630.,    750.,   800., 1000.,  1250.,
			1500.,   1600.,  2000.,  2500.,   3000.,  3150., 4000.,  5000.,
			6000.,   6300.,  8000.,  9000.,  10000., 11200.,12500., 14000.,
			15000.,  16000.
  };
	
  double ex_at_thr[35] = {
    33.0,
			28.18,   23.9,   19.2,   15.68,   12.67,  10.09,  8.08,   6.30,
			5.3,     4.5,    3.63,   3.63,    3.63,   3.63,  3.63,   3.63,
			3.63,    3.63,   3.63,   3.63,    3.63,   3.63,  3.63,   3.63,
			3.63,    3.63,   3.63,   3.63,    3.63,   3.63,  3.63,   3.63,
			3.63,    3.63
  };
	
  return (lin_int(ex_at_thr-1,Hz-1,frqHz,n_thr));
}
/*-------------------------------------------------------------*/
double alpha100(double G_dB)
{
  /* Table of alpha vs G_dB for equal N' at 100 dB */
  double lin_int(double *yy,double *xx, double x,unsigned long n);
	
  unsigned long n_thr = 15;
	
  double Gtable[15] = {
    0.0,   -5.0,  -10.0,  -20.0,   -25.,  -30.0,  -35.0,
			-40.0,  -45.0,  -50.0,  -55.0,  -60.0,  -65.0,  -66.0,  -67.0
  };
	
  double alpha_table[15] = {
    0.2,     .21055, .22228, .25016, .26691, .28609, .30825,
			.33419, .36499, .40229, .44869, .50953, .60486, .63930, .74660
  };
  return (lin_int(alpha_table-1,Gtable-1,G_dB,n_thr));
}
/*-------------------------------------------------------------*/
double Btable(double alpha)
{
/* 10**(3.63/10)**alpha *[(1+B)**alpha - B**alpha] = 
* 10**(3.63/10)**alpha *[  3  **alpha - 2**alpha] = 
*  = 0.11468789974374155
	*/
  double lin_int(double *yy,double *xx, double x,unsigned long n);
	
  unsigned long n_thr = 92;
	
  double alpha_tab[92] = {
    0.01,      0.02,      0.03,      0.04,      0.05,      0.06,
			0.07,      0.08,      0.09,      0.10,      0.11,      0.12,
			0.13,      0.14,      0.15,      0.16,      0.17,      0.18,
			0.19,      0.20,      0.21,      0.22,      0.23,      0.24,
			0.25,      0.26,      0.27,      0.28,      0.29,      0.30,
			0.31,      0.32,      0.33,      0.34,      0.35,      0.36,
			0.37,      0.38,      0.39,      0.40,      0.41,      0.42,
			0.43,      0.44,      0.45,      0.46,      0.47,      0.48,
			0.49,      0.50,      0.51,      0.52,      0.53,      0.54,
			0.55,      0.56,      0.57,      0.58,      0.59,      0.60,
			0.61,      0.62,      0.63,      0.64,      0.65,      0.66,
			0.67,      0.68,      0.69,      0.70,      0.71,      0.72,
			0.73,      0.74,      0.75,      0.76,      0.77,      0.78,
			0.79,      0.80,      0.81,      0.82,      0.83,      0.84,
			0.85,      0.86,      0.87,      0.88,      0.89,      0.90,
			0.91,      0.92
  };
	
  double B[92] = {
    0.00000571,0.00252720,0.01960681,0.05627271,0.10925538,0.17476906,
			0.25027058,0.33427592,0.42600493,0.52513220,0.63163592,0.74570931,
			0.86770954,0.99812912,1.13758120,1.28679392,1.44661106,1.61799732,
			1.80204766,2.0000000, 2.21325148,2.44337832,2.69215966,2.96160589,
			3.25399210,3.57189776,3.9182534, 4.29639600,4.71013452,5.16382788,
			5.66247784,6.211840,  6.81855707,7.49031918,8.23605766,9.06618007,
			9.99285649,11.03036975,12.19554562,13.50828397,14.99221742,
			16.67553251,
			18.59199859,20.78226431,23.29550040,26.19149403,29.54333535,
			33.44088652,
			37.99529191,43.34488444,49.66297907,57.16823859,66.13857684,
			76.92997209,
			90.00216295, 105.95409238, 125.57330955, 149.90559031,
			180.35420636, 218.82324025,
			267.92724471, 331.30231409, 414.07461991, 523.57757132,
			670.46863172, 870.50102662,
			1147.3909542, 1537.5585325, 2098.1513700, 2920.9702664,
			4157.3101323, 6063.6158435,
			9088.1831841, 14041.821870, 22447.345001, 37287.289303,
			64683.400120, 117879.71596,
			227283.57523, 467585.97052, 1036992.6567, 2510480.6150,
			6738019.7457, 20441394.617,
			71836001.367, 301800787.45, 1579616251.0, 10882006532.,
			106352900483., 1637706124478., 47578435111555., 226700989698406.
  };
  return (lin_int(B-1,alpha_tab-1,alpha,n_thr));
}
/*--------------------------------------------------------------------*/
/* This function returns a linear version of K  */
double calc_K(double freqkHz)
{
  double lin_int(double *yy,double *xx, double x,unsigned long n);
	
  unsigned long n_thr = 23;
  double temp;
	
  double freq_kHz[23] = {
    0.0,
			0.05,  0.063, 0.08 ,   0.1, 0.125, 0.160,
			0.20,  0.25 , 0.315,   0.4, 0.5  , 0.630,  0.75,  0.8,
			1.00,  1.1  , 2.   ,   4.0, 8.0  ,10.000, 15.0 , 20.0
  };
  
  double KdB[23] = {
    20.0,
			13.5,   10.0,   7.2,  4.9 ,   3.1,   1.6,
			0.4,   -0.4,  -1.2, -1.85,  -2.4,  -2.7, -2.85, -2.9,
			-3.0,   -3.0, -3.0 , -3.0 ,  -3.0,  -3.0,  -3.0, -3.0
  };
	
  if(freqkHz >= 1.00)  return (pow(10.0,(-3.0/10.0)));
	
  temp = lin_int(KdB-1,freq_kHz-1,freqkHz,n_thr);
  return (pow(10.0,(temp/10.0)));
}
/*--------------------------------------------------------------------*/
#if 0

NOW COMMENTED OUT

This was used with the original stereoloud.c

double so2phons(double sones)
{
	/* put in sones (x), return phons(y) */
	
  double lin_int(double *yy,double *xx, double x,unsigned long n);
	
  unsigned long n_thr = 36;
  double lsones;
	
  /* table of log2(sones)*/
  double logsones[36] = {
    -29.6610,
		 -23.0303, -18.8070, -14.7131, -10.8323,   -9.3916,
			-8.0460,  -7.4169,  -6.1527,  -5.2903,   -3.9284,
			-2.8594,  -1.9850,  -1.2436,  -0.5907,    0.0000,
       0.5471,   1.0650,   1.5610,   2.0420,    2.5150,
       2.9840,   3.4540,   3.9340,   4.4350,    4.9550,
       5.4830,   6.0170,   6.6049,   7.3267,    8.1587,
       9.1324,  10.3711,  11.7365,  13.1229,   14.3007
  };
  
  /*  matching table of phons */

  double stdphons[36] = {
		 -20.0,
		 -15.0,      -10.0,      -5.0,       0.0,       2.0,   
			 4.0,        5.0,       7.5,      10.0,      15.0,   
			20.0,       25.0,      30.0,      35.0,      40.0,   
			45.0,       50.0,      55.0,      60.0,      65.0,   
			70.0,       75.0,      80.0,      85.0,      90.0,   
			95.0,      100.0,     105.0,     110.0,     115.0,   
		 120.0,      125.0,     130.0,     135.0,     140.0
  };
	
  
  /*  matching table of phons */
  double stdphons[36] = {
		 -20.0,
		 -15.0,      -10.0,      -5.0,       0.1,       2.1,   
			 4.1,        5.1,       7.6,      10.1,      15.1,   
			20.1,       25.1,      30.1,      35.1,      40.1,   
			45.1,       50.1,      55.1,      60.1,      65.1,   
			70.1,       75.1,      80.1,      85.1,      90.1,   
			95.1,      100.1,     105.1,     110.1,     115.1,   
		 120.1,      125.1,     130.1,     135.1,     140.1
  };
	
  if(sones <= 0.5e-8) return(-25.0);
	
  lsones = log10(sones)/log10(2.0);
  /*  printf("sones %.1f, lsones %.1f\n",sones,lsones); */
  if(lsones > logsones[n_thr-1]+.0001) return(999.0); /* about 140 dB !! */
  return (lin_int(stdphons-1,logsones-1,lsones,n_thr));
	
}
#endif

//-------------------------------------------------------------
// new so2phons for TVLBIN   binaural inhibition method of calc stereo loudness

double so2phons(double sones)  // for loudaes2.c the "NEW in Aug 2006" monaural to binaural conversion
{
// put in sones (x), return phons(y)

#define NSONES 39

  double lin_int(double *yy,double *xx, double x, unsigned long n);
	
  long i;
  double lsones, log10_2, logsones[NSONES];
	

  // table of sones
#if 0
  COMMENTED OUT
  double sones_tab[NSONES] = {
        1.0e-15,     2.30e-11,   2.30e-11,   1.24e-9, 
        1.10e-7,     2.07e-6,    3.55e-5,    0.00052,    0.00095, 
        0.00364,     0.00563,    0.00799,    0.02522,    0.06482, 
        0.13646,     0.25117,    0.42090,    0.66311,    1.00000, 
        1.46217,     2.09187,    2.94719,    4.11055,    5.69979, 
        7.86644,    10.92900,   15.24120,   21.55690,   30.90470, 
       44.52560,    64.39189,   96.89180,  159.34140,  283.04220, 
      554.20697,  1301.66200, 3343.30000, 8725.00000,19850.00000
  };
#endif

  // new ( Feb 2011) table of sones
  double sones_tab[NSONES] = {
        1.0e-15,     2.30e-11,   2.30e-11,   1.19e-9, 
        1.15e-7,     2.15e-6,    3.67e-5,    5.41e-4,    0.00166,
        0.0037,      0.00578,    0.0141,     0.02547,    0.06523,
        0.1370,      0.251795,   0.421468,   0.66349,    1.00000,
        1.46217,     2.09187,    2.94719,    4.11055,    5.69979, 
        7.86644,    10.92900,   15.24120,   21.55690,   30.90470, 
       44.52560,    64.39189,   96.89180,  159.34140,  283.04220, 
      554.20697,  1301.66200, 3343.30000, 8725.00000,19850.00000
  };
   
    
    
    /*  matching table of phons */
  double stdphons[NSONES] = {
  		  -30.0,       -25.0,      -24.0,      -20.0, 
	  	  -15.0,       -10.0,       -5.0,        0.0,        2.2,    
		  	  4.0,         5.0,        7.5,       10.0,       15.0,    
			   20.0,        25.0,       30.0,       35.0,       40.0,    
  			 45.0,        50.0,       55.0,       60.0,       65.0,    
	  		 70.0,        75.0,       80.0,       85.0,       90.0,    
		  	 95.0,       100.0,      105.0,      110.0,      115.0,    
        120.0,       125.0,      130.0,      135.0,      140.0
  };
	
  lsones = log10(sones)/log10(2.0);
  log10_2 = log10(2.0);
  for ( i = 0 ; i < NSONES ; i++) logsones[i] = log10(sones_tab[i])/log10_2;


  if(sones <= 1.15e-9) return(-25.0); // log10(sones = -25)/log10(2) 
	
	if(lsones > logsones[NSONES-1]+.0001) return(999.0); // about 140 dB !!
  return (lin_int(stdphons-1,logsones-1,lsones,NSONES));    //zzz - 0.1; //  correction for 1kHz stereo 10-100 dB
}

//-------------------------------------------------------------
/* Function fqtoerb converts a frequency in Hz to the corresponding E value.*/
double fqtoerb (double fq)
{  return( C3 * log10((C2 * fq/1000.0) + 1.0)); }
/*-------------------------------------------------------------

* Function erbtofq converts the E value to its corresponding frequency in Hz.*/
double erbtofq(double E) /* (1000 * (10**(E/C3) -1) )/C2  */
{ return (1000.0 * (pow(10.0,(E/C3)) - 1.0) / C2); }
/*-------------------------------------------------------------*/

int power(int x,int n)
{
  int p;
  for( p = 1 ; n > 0 ; --n) p = p * x;
  return(p);
}
/*---------------------------*/

void scalefft(double *rwave, long npts, double dBmax, long ndata)
{
	/* function scalefft:   put power (magnitude squared) into rwave */
	
  long i, j, npts2;
  double added_dB, std_rms = 0.707106781;
	
	
  npts2 = npts/2;
  added_dB = 10.0*log10((double)npts/(double)ndata);
	
  for( i=1, j=1 ; i < npts ; i +=2, j++){
    rwave[j] = sqrt(2.0*(rwave[i]*rwave[i] + rwave[i+1]*rwave[i+1])/(double)(npts*npts));
  }
	
	/* scale power to sqrt2/2 = dBmax */
  for ( i = 1 ; i <= npts2 ; i++){
    if(rwave[i] > 0.0) rwave[i] = 20.*log10(rwave[i]/std_rms)+dBmax+HANN_CORR+added_dB;
    else rwave[i] = -200.0;
  }
}

/*-------------- function calc_ex() ---------------------*/

void calc_ex(double *Eint, double *compfq, double *sig_int, long ncomps, double *erbdB)
{
  /* calculate excitation pattern */
  long ncalcerb, comp;
  double erbtofq(double E);
  double E, frqHz, frqkHz, erb, p51, intensity, p, g;
	
  ncalcerb = 0;
  for( E = ESTART ; E <= EEND ; E += ESTEP){
    ncalcerb++;
    frqHz = erbtofq(E);
    frqkHz = frqHz/1000.0;
    erb = C1 * (C2 * frqkHz + 1.0);
    p51 = 4.0 * frqHz/erb;
    intensity = 0.0;
#ifdef DEBUG
		/* printf("E = %6.2f  frq Hz = %6.1f   erb = %6.1f   p51 = %5.1f\n",E,frqHz,erb,p51);*/
#endif
		
		
    for (comp = 1 ; comp <= ncomps ; comp++){
      g = (compfq[comp]-frqHz)/frqHz;
			
			
#ifdef DEBUG
			/*printf(" !!  comp = %2d compfq = %4.0f Hz = %6.1f g = %8.3f  !!\n",comp,compfq[comp],frqHz,g);*/
#endif
			
      if(g > 2.0) break;
      if(g < 0.0) p= p51 - .350 * (p51/p51_1k) * (erbdB[comp]-51.0);
      if(g >= 0.0) p = p51;
      if(p < 0.01) p = 0.01; /* pl can go -ve for tones > 130 dB ! */
			
#ifdef DEBUG
														 /*printf("(comp %2ld  Efreq %6.1f  comp_frq %6.1f  erbdB[comp] %6.1f  p %3.1f\n",
			comp,frqHz,compfq[comp],erbdB[comp],p);*/
#endif
			
      g = fabs(g);
      intensity += ((1.0+p*g)*exp((-p*g))*sig_int[comp]);
    }
    if (intensity < 1.0e-10) intensity = 1.0e-10;
		Eint[ncalcerb] = intensity;
  }
}
